#include <stdio.h>
#include <unistd.h> 
#include <sys/io.h>

// Procedury

int read_port(int port_)
{
	int read_data;
	if (setuid (0) < 0) {    
		printf ("Program musi byt spusten rootem\n");
		exit (1);
	}
	if (ioperm (port_, 8, 1)) { 
		printf ("Neni pristup na port\n");
	   	exit (1);
	}
	read_data = inb(port_);
	ioperm(port_,8,0);    
	return read_data;
}

// --------------------------
// Start programu
// ----------------------------

int main (int argc,char *argv[]) 
{
	int port,data;
	if (argc<3) {
		printf("Spatne zadany parametry\n");
		printf("1) cteni z portu: ./port In <cislo portu dekadicky>\n");
		printf("2) zapis do portu: ./port Out <cislo portu dekadicky> <data dekadicky>\n");
		printf("0x378 - 888 dekadicky\n");
		exit(1);
	}
	
	// Cteni z portu
	if ((argv[1]="In") && (argc==3)) {
		port = atoi(argv[2]);
		fprintf(stdout,"%d",read_port(port));
	}

	// Zapis na port
	if ((argv[1]="Out") && (argc==4)) {
		port = atoi(argv[2]);
		data = atoi(argv[3]);
		
		if (setuid (0) < 0) {printf ("Program musi byt spusten rootem\n");exit (1);}
		if (ioperm (port, 8, 1)) {printf ("Neni pristup na port\n");exit (1);}
		outb(data,port);
		ioperm(port,8,0);    
	}
}
